"""
    Ubiquity REST API

    Ubiquity provides a RESTful and uniform way to access accountchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar  #### Testnet Testnet support coming soon  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""

import unittest

import httpretty

import test.mock
import test.utils
from ubiquity import Configuration
from ubiquity.api import (
    balances__utxo_api,
    ApiClient,
)


class TestBalancesUTXOApi(unittest.TestCase):
    """BalancesUTXOApi unit test stubs"""

    def setUp(self):
        self.api_client = ApiClient(Configuration())
        self.api_instance = balances__utxo_api.BalancesUTXOApi(
            self.api_client)  # noqa: E501
        self.protocols = test.utils.get_protocols()
        self.accounts_by_protocol = {
            "algorand":
                "5K6J3Z54656IR7YY65WNJT54UW6RBZZYL5LWQUTG4RWOTRTRBE2MR2AODQ",
            "bitcoin": "bc1q0e3vshzcp8kntj2ynqaxt32sqshqf36tl8xdmz",
            "ethereum": "0x30B2f83e291f952850DFB13380F6c71b24FDF97c",
            "polkadot": "1622aMEugx8d9FMEPJaknxCR5eUXSCJA5GANhdxYxwgA29vH",
            "stellar":
                "GDJ5VRKEVCDDFQPI3UYAJPU35NHPCML3JCFYH7J456GAOAL3NKVSE7YM",
            "xrp": "rh3VLyj1GbQjX7eA15BwUagEhSrPHmLkSR"
        }

        # Assert all listed protocols have an account id created above for testing
        assert len(self.accounts_by_protocol) == len(self.protocols)

    def tearDown(self):
        pass

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_account_balances(self):
        network = 'mainnet'
        supported_protocols = test.mock.get_supported_protocols(
            self.protocols, '/account/:address')
        assert len(supported_protocols) > 0
        for protocol in supported_protocols:
            account_id = self.accounts_by_protocol[protocol]
            print(f"/{protocol}/{network}/account/{account_id}")
            test.mock.setup_mock_server(self.api_client.configuration.host, [{
                "req_url":
                    f"/{protocol}/{network}/account/{account_id}",
                "method":
                    httpretty.GET,
                "status":
                    200,
                "response_data":
                    test.mock.get_mock_file_content(
                        f'balances__utxo_api/{protocol}_account_{account_id}.json')
            }])
            _ = self.api_instance.get_list_of_balances_by_address(protocol, network, account_id)

if __name__ == '__main__':
    unittest.main()
